/*
 * @Author: 抠脚本人
 * @QQ: 742374184
 * @Date: 2022-12-14 16:26:15
 * @LastEditTime: 2022-12-18 20:39:37
 * @Description:补充的d.ts
 * 灵感来之不易,积累创造奇迹
 */
interface ListData {
	[key: string]: string | number | boolean | undefined;
}
interface AutojsViewHolder extends androidx.recyclerview.widget.RecyclerView.ViewHolder {
	get position(): number;
	get data(): ListData;
}

declare module "ui/view" {
	class V8RecyclerViewAdapter extends androidx.recyclerview.widget.RecyclerView.Adapter<AutojsViewHolder> {}
	class AutoJsRecyclerView extends androidx.recyclerview.widget.RecyclerView {
		on(event: "bind_item", callback: (itemView: JsView<android.view.ViewGroup>, data: ListData, position: number, viewType: string, holder: AutojsViewHolder) => void);
		on(event: "item_created", callback: (itemView: JsView<android.view.ViewGroup>, holder: AutojsViewHolder, viewType: string) => void);
		getAdapter(): V8RecyclerViewAdapter;
		setItemTemplate(xml: string);
		setDataSource(data: ListData[]);
		getDataSource(): ListData[] | null;
	}
	type V8RecyclerView = JsView<AutoJsRecyclerView>;
	interface JsViewExt {
		on(event: "click", callback: (param: { view: JsView<android.view.View>; consumed: boolean }) => void);
		on(event: string, callback: (...args: any[]) => void);
	}
}
